'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Build tasks module.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * @module gettext-js/src/build/tasks
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */


var _babelJsxgettext = require('babel-jsxgettext');

var _babelJsxgettext2 = _interopRequireDefault(_babelJsxgettext);

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _gulpLoadPlugins = require('gulp-load-plugins');

var _gulpLoadPlugins2 = _interopRequireDefault(_gulpLoadPlugins);

var _gulpPo2json = require('gulp-po2json');

var _gulpPo2json2 = _interopRequireDefault(_gulpPo2json);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var $ = (0, _gulpLoadPlugins2.default)();

/**
 * Class for registering gulp task for managing PO files
 */

var _class = function () {
  /**
   * Initialize the build utils class.
   * @param {Object} gulp - A gulp instance reference
   * @param {String} sourceJs - Path to Javascript files containing gettext keywords
   * @param {String} localeMainFile - Path to main POT file
   * @param {String} sourceLocale - Path to PO files containing translations
   * @param {String} destLocale - Path to JSON files to use in the application
   */
  function _class(gulp, sourceJs, localeMainFile, sourceLocale, destLocale) {
    _classCallCheck(this, _class);

    this.gulp = gulp;

    this.sourceJs = sourceJs; //'src/**/*.js'
    this.localeMainFile = localeMainFile; //'locale/template.pot'

    this.sourceLocale = sourceLocale; // 'locale/*.po'
    this.destLocale = destLocale; // 'src/locale'
  }

  /**
   * Loads gulp tasks for gettext-js.
   */


  _createClass(_class, [{
    key: 'load',
    value: function load() {
      var _this = this;

      /**
       * Update POT file (this.localeMainFile) with new keys.
       * It parses source javascript files (this.sourceJs) looking for the key 'gettext'
       */
      this.gulp.task('gtx:locale-update', function () {
        (0, _babelJsxgettext2.default)(_glob2.default.sync(_this.sourceJs), _this.localeMainFile, null, function (err) {
          if (err) {
            $.util.log(err);
          }
        });
      });

      /**
       * Converts PO files to JSON using Jed 1.x syntax
       */
      this.gulp.task('gtx:locale-build', function () {
        return _this.gulp.src(_this.sourceLocale).pipe((0, _gulpPo2json2.default)({ format: 'jed1.x' })).pipe(_this.gulp.dest(_this.destLocale));
      });
    }
  }]);

  return _class;
}();

exports.default = _class;